function [assignments,points]=camb_mech(sch_ranks,paidlunch,sch_seats,pl_seats,fl_seats,priorities,lotteries)
    [N,K]=size(sch_ranks);        % Number of students / Ranks
    J=numel(sch_seats);          % Number of programs
    
    assignments=zeros(N,1);
    round = (K+1)*ones(J,2);  % Default 4
    score = zeros(J,2);       % Default 0  
    
    assert(numel(paidlunch)==N)
    assert(numel(pl_seats)==J)
    assert(numel(fl_seats)==J)
    assert(isequal(size(priorities),[N,J]));
    assert(isequal(size(lotteries),[N,1]));
    
    
    for rr=1:K
        
        for ss=1:J
            % Find the students that ranked school ss and were not assigned previously
            ranked=sch_ranks(:,rr)==ss & assignments==0;
            tot_ss = sum(ranked);
            tot_pl = sum(ranked & paidlunch);
            tot_fl = sum(ranked & ~paidlunch);
            cut_pl = 0; cut_fl = 0; cut_ss = 0;
            %[rr,ss,100*pl_seats(ss)/tot_pl]
            if pl_seats(ss) ==0, cut_pl = inf; else
                if tot_pl >= pl_seats(ss), cut_pl = -prctile(-(priorities(ranked & paidlunch,ss)+lotteries(ranked & paidlunch)),100*(pl_seats(ss)-0.5)/tot_pl); end
            end
            if fl_seats(ss) ==0, cut_fl = inf; else
                if tot_fl >= fl_seats(ss), cut_fl = -prctile(-(priorities(ranked & ~paidlunch,ss)+lotteries(ranked & ~paidlunch)),100*(fl_seats(ss)-0.5)/tot_fl); end
            end
            clears_pl = ranked & paidlunch & priorities(:,ss)+lotteries >=cut_pl;
            clears_fl = ranked & ~paidlunch & priorities(:,ss)+lotteries >=cut_fl;
            if sch_seats(ss) ==0, cut_ss = inf; else
                if sum(clears_pl+clears_fl) >= sch_seats(ss), cut_ss = -prctile(-(priorities(clears_pl | clears_fl,ss)+lotteries(clears_pl | clears_fl)),100*(sch_seats(ss)-0.5)/ sum(clears_pl+clears_fl)); end
            end
            clears_ss = (clears_pl | clears_fl) & priorities(:,ss)+lotteries >=cut_ss;
            assignments(clears_ss) = ss;
            sch_seats(ss) = sch_seats(ss)  - sum(clears_ss);
            pl_seats(ss) = pl_seats(ss)  - sum(clears_ss & paidlunch);
            fl_seats(ss) = fl_seats(ss)  - sum(clears_ss & ~paidlunch);
            %[rr,ss,cut_pl,cut_fl,cut_ss]
            if (sch_seats(ss)==0 | pl_seats(ss)==0) & round(ss,1)>rr
                round(ss,1) = rr;
                score(ss,1) = max(cut_ss,cut_pl);
            end
            if (sch_seats(ss)==0 | fl_seats(ss)==0) & round(ss,2)>rr
                round(ss,2) = rr;
                score(ss,2) = max(cut_ss,cut_fl);
            end    
                
        
        end
    end    
    
    points.round = round;
    points.score = score;
end

