% Mean utility includes distance

function [cutoffs] = compute_DA_cutoffs(mean_util,sigma,priority_mat,elig,paidlunch,qty,consolidate,this_seed)
    
    rng(this_seed);
    
    % Redraw
    n_stu_counter = size(mean_util,1);
    n_progs = length(consolidate.map);
    stu_sample=ceil(rand(n_stu_counter-1,1)*n_stu_counter);
    
    % Compute eligibility and priority
    elig_counter=elig(stu_sample,:);   
    p=priority_mat(stu_sample,:)+repmat(rand(n_stu_counter-1,1),1,size(priority_mat,2)); % School Preferences - row i column j is p_ij                
    paidlunch = paidlunch(stu_sample);
    
    
    % Draw utilities
    V = mvnrnd(mean_util(stu_sample,:),sigma);
    V=[V(:,consolidate.map) zeros(n_stu_counter-1,1)];               % Define school level preferences, add outside option
    elig_counter(:,end+1) = 1;
    % Compute the match
    [match,cutoffs.pl,cutoffs.fl]=da_alg_camb(V',p,qty.sch,qty.pl,qty.fl,paidlunch == 1,elig_counter == 1);      % Row i is the match of student i    
    
    
end