

%% Lottery Estimation Log

% Overview:
% This section estimates assignment probabilities for each possible rank order list.

% For point estimate: use observed sample;
% Draw NSUB = 1000 bootstrap (size N with replacement) samples for inference;
% For each sample (observed or bootstrap) we obtain an estimate of assignment probabilities under each of the alternative
% behavioral assumptions. For the rational expectations model (current_year_ts), we compute the probabilities by simulation.
% In each simulation, we randomly draw N-1 students from the sample (observed or bootstrap) and a tie-breaker vector,
% run the cambridge mechanism and store the resulting vector of market clearing cutoffs. We collect cutoffs for 
% NSIM = 1000 simulations. Finally, for each student type and possible rank order list we compute the probability
% of assignment in each school using the distribution of cutoffs obtained by simulation. For each simulation, student type and
% rank order list, we compute the probability of assignment to each school given the simulated cutoffs. Then we average across
% simulations to obtain the average for student type and rank order list. 


% 1. Create the raw file with all the draws
% gen_cutoffs_camb_ts;        % generates structure with cutoffs: draws_ts.mat

% 2. Generate Lottery files and constraints for each specification;
% gen_constraints_ts; % 


% 3. Run bootstrap samples
% run_bootstrap_samples_ts;


