
function [lott,smpl,student_type] = gen_lott_file(draw_file,drawnum,is_last_year)

load(draw_file);
if numel(size(estm))==4, estm=squeeze(estm(:,:,1,:)); end
if nargin<2, drawnum =0; end
if nargin<3, is_last_year =0; end
[s1,s2,s3] = size(estm); %year,NSUB,NPROG*2;
NPROG = s3/2;
if drawnum ==0
    %draw = reshape(draw,[s1,s2*s3,s4]);
	draw = estm;
    smpl = 1:numel(student_type);
else
    draw = squeeze(draw(:,drawnum,:,:));
    smpl = sort(bsmp(drawnum,:));
end

        
lott = struct();
for tt = 1:numel(styp)
    student_year = unique_types(tt,1);
    year_index = (student_year-min(unique_types(:,1))+1 - is_last_year);
    if year_index >0
        points = squeeze(draw(year_index,:,:));
        lott(tt).p = camb_mech_points(styp(tt).choice,styp(tt).paidlunch,styp(tt).priorities,points);
		lott(tt).choice = styp(tt).choice;
        %check_monotonicity; keyboard;
        fprintf('.')
    % Modify lott structure to allow for partial lists
        [~,uniq_ch_row]=unique(lott(tt).choice(:,1:2),'rows');
        for ii=1:size(uniq_ch_row,1)
            lott(tt).choice=[lott(tt).choice; [lott(tt).choice(uniq_ch_row(ii),1:2) NaN]];
            temp_p=zeros(1,NPROG);
			temp_p(lott(tt).choice(uniq_ch_row(ii),1:2))=lott(tt).p(uniq_ch_row(ii),lott(tt).choice(uniq_ch_row(ii),1:2));
            lott(tt).p=[lott(tt).p; temp_p];        
        end
        
        % Modify lott structure to allow for unitary list
        [~,uniq_ch_row]=unique(lott(tt).choice(:,1),'rows');
        for ii=1:size(uniq_ch_row,1)
            lott(tt).choice=[lott(tt).choice; [lott(tt).choice(uniq_ch_row(ii),1) NaN NaN]];
            temp_p=zeros(1,NPROG);
            temp_p(lott(tt).choice(uniq_ch_row(ii),1))=lott(tt).p(uniq_ch_row(ii),lott(tt).choice(uniq_ch_row(ii),1));
            lott(tt).p=[lott(tt).p; temp_p];        
        end

        % Modify lott structure to allow for null list
        lott(tt).choice = [lott(tt).choice; [NaN NaN NaN]];
        lott(tt).p(end+1,:) = zeros(1,NPROG);
        
        % Turn into sparse
        lott(tt).p=sparse(lott(tt).p);
    end
end
