
% % Choose how you want to compute the A matrix
% method = 'last_year'; % How to form the A matrix: fullinfo, current_year, past_year, truthful



%% Load stuff: Comment out the next two lines if it's already loaded
%load('estimation/second_stage.mat');
constraint_matrix = cell(ns, 1);
V = zeros(ns,n_progs);
if ~isequal(method,'truthful') % Other than Truthful
    firststage=load(['../est_lotteries/' method],...
        'constraint_matrix','rationalized_students','student_type','lott','tag');
    fprintf('Done loading.\n');
    
    A=sparse(1:numel(consolidate.map),consolidate.map,ones(numel(consolidate.map),1));
    constraint_matrix = cell(size(firststage.constraint_matrix)); 
    rationalized_students = firststage.rationalized_students;
    tag = firststage.tag;
    my_eps = 1;
    s = 1;
    while s<=ns
        try 
            rem_redundant_wrap
        catch me
            disp(me), keyword
        end
    end
else % Truthful;
    all_p = [1:n_progs]';
    for s = 1:ns
        [isit,where]=ismember([1,2,3]',rank.data(s,:));
        where = where(isit); isit=isit(isit); 
        where = consolidate.map(where); 
        unrk = all_p; unrk(where)=[];
        numrk = sum(isit);
        if numrk==3 % Then the third option is better than all unranked and the outside option.
            constraint_matrix{s} = sparse([where; unrk; where(1:end-1); unrk],...
                [where; where(3)*ones(n_progs-numrk,1); where(2:end); unrk],...
                [ones(n_progs,1); -ones(n_progs-1,1)],n_progs,n_progs);
            V(s,where) = [3 2 1];
            % (where,where,1)  - (where(1:end-1), where(2:end),1): first
            % ranked better than second, second than third and third than
            % outside;
            % (unrk, where(3)*ones(n_progs-numrk,1),1) - (unrk,unrk,1):
            % third is better than others not ranked.
        else % Then the last ranked option is better than the outside which is better than the unranked
            constraint_matrix{s} = sparse([where; where(1:end-1); unrk],...
                [where; where(2:end); unrk],...
                [ones(numrk,1); -ones(n_progs-1,1)],n_progs,n_progs);
            V(s,where) = numrk:-1:1; V(s,unrk)=-1;
            % (where,where,1)  - (where(1:end-1), where(2:end),1): first
            % ranked better than second, and second than the outside (if numrk==2)
            % of first ranked is better than outside if numrk==1. 
            % 0 - (unrk,unrk,1): unranked are worse than the outside.
        end
        tag{s} = false(size(constraint_matrix{s},1),1);
        assert(all(constraint_matrix{s}*V(s,:)'>0));
    end
    
end

