% Original (Top 2 as sorted);

%% Generate prxd: Our proximities according to distances:
original = prox;
original.mapRC= [1 2 3 3 4 5 6 7 8 8 8 9 10 11 12 13]; % From the restricted set to the complete set;
[~,original.mapCR] = unique(original.mapRC); % From the complete set to the restricted set;   
[~,A]=sort(dists(:,original.mapCR),2); top2=A(:,[1 2]);
original.dataR = sparse([1:ns 1:ns],top2(:),ones(2*ns,1));
original.data = original.dataR(:,original.mapRC);
[lpr,lns]=meshgrid(1:size(A,2),1:ns);
original.sch_dist_rankR = full(sparse(lns(:),A(:),lpr(:)));
original.sch_dist_rank = original.sch_dist_rankR(:,original.mapRC);
prox_restr = original.dataR*0; cc=0;
for c = original.mapRC
    cc=cc+1;
    prox_restr(:,c) =  prox_restr(:,c)+ prox.data(:,cc);
end
% Let's look at the schools that received priority
given_priority = full(original.sch_dist_rank.*prox.data);
% Now let's look at the schools that were not given priority and were
% ranked
not_given_priority = full(original.sch_dist_rank.*(~prox.data & rank.data>0));
not_given_priority(not_given_priority==0)=inf;
or_stud.given_right_priorities =  max(given_priority,[],2)<3;
or_stud.refused_right_priorities = min(not_given_priority,[],2)>2;
or_stud.ok = or_stud.refused_right_priorities & or_stud.given_right_priorities;
fprintf('Original hit rate: %0.2f\n',sum(or_stud.ok)/numel(or_stud.ok));

% New (Two closest);
new = prox;
new.mapRC= [1 2 3 3 4 5 6 7 8 8 8 9 10 11 12 13]; % From the restricted set to the complete set;
[~,new.mapCR] = unique(new.mapRC); % From the complete set to the restricted set;   
D=sort(dists(:,new.mapCR),2); 
distInBound =bsxfun(@minus,(D(:,2) + D(:,3))/2,dists(:,new.mapCR));
new.dataR=distInBound >-eps;
% verify verify=sum(prxd.dataR,2); [min(verify) max(verify)]
new.data = new.dataR(:,new.mapRC);
% Verify is priorities were assigned ok
prox_restr = new.dataR*0; rank_restr = prox_restr; rejc_restr=rank_restr; redn_restr=rank_restr; cc=0;
asgn_rank = max(rank.data .* asgn.data,[],2); asgn_rank(asgn_rank==0)=5;
for c = new.mapRC
    cc=cc+1;
    prox_restr(:,c) =  prox_restr(:,c)+ prox.data(:,cc);
    rank_restr(:,c) =  rank_restr(:,c)+ rank.data(:,cc);
    rejc_restr(:,c) =  rejc_restr(:,c)+ (rank.data(:,cc)<asgn_rank);
    redn_restr(:,c) =  redn_restr(:,c)+ (rank.data(:,cc)>asgn_rank);
end

ne_stud.given_right_priorities =  max(max(prox_restr .* distInBound,[],2),0);
ne_stud.given_right_priorities_redundant =  max(max(redn_restr .* prox_restr .* distInBound,[],2),0);
ne_stud.given_wrong_priorities =  -min(min(prox_restr .* distInBound,[],2),0);
ne_stud.refused_right_priorities = -min(min(rank_restr .* (1-prox_restr) .* distInBound,[],2),0);
ne_stud.refused_wrong_priorities =  max(max(rank_restr .* (1-prox_restr) .* distInBound,[],2),0);
ne_stud.refused_wrong_priorities_rejected =  max(max(rank_restr .*rejc_restr .* (1-prox_restr) .* distInBound,[],2),0);
ne_stud.ok = (ne_stud.refused_wrong_priorities==0) & (ne_stud.given_wrong_priorities==0);
fprintf('New hit rate: %0.2f\n',sum(ne_stud.ok)/numel(ne_stud.ok));


%Newer (Two closest thinking as amigos and MLK as one);

newer = prox;
newer.mapRC= [1 2 3 3 4 5 6 7 8 8 8 9 10 11 12 13]; % From the restricted set to the complete set;
[~,newer.mapCR] = unique(newer.mapRC); % From the complete set to the restricted set;   
only_distinct_distances = [1 2 3 6 7 8 9 12 13 14 15]; %Pooled Amigos/MLK, Tobins, King Open/ King Open Ola
D=sort(dists(:,only_distinct_distances),2); 
distInBound =bsxfun(@minus,(D(:,2) + D(:,3))/2,dists(:,newer.mapCR));
newer.dataR=distInBound >-eps;
% verify verify=sum(prxd.dataR,2); [min(verify) max(verify)]
newer.data = newer.dataR(:,newer.mapRC);
% Verify is priorities were assigned ok
prox_restr = newer.dataR*0; rank_restr = prox_restr; rejc_restr=rank_restr; redn_restr=rank_restr; cc=0;
asgn_rank = max(rank.data .* asgn.data,[],2); asgn_rank(asgn_rank==0)=5;
for c = newer.mapRC
    cc=cc+1;
    prox_restr(:,c) =  prox_restr(:,c)+ prox.data(:,cc);
    rank_restr(:,c) =  rank_restr(:,c)+ rank.data(:,cc);
    rejc_restr(:,c) =  rejc_restr(:,c)+ (rank.data(:,cc)<asgn_rank);
    redn_restr(:,c) =  redn_restr(:,c)+ (rank.data(:,cc)>asgn_rank);
end

nr_stud.given_right_priorities =  max(max(prox_restr .* distInBound,[],2),0);
nr_stud.given_right_priorities_redundant =  max(max(redn_restr .* prox_restr .* distInBound,[],2),0);
nr_stud.given_wrong_priorities =  -min(min(prox_restr .* distInBound,[],2),0);
nr_stud.refused_right_priorities = -min(min(rank_restr .* (1-prox_restr) .* distInBound,[],2),0);
nr_stud.refused_wrong_priorities =  max(max(rank_restr .* (1-prox_restr) .* distInBound,[],2),0);
nr_stud.refused_wrong_priorities_rejected =  max(max(rank_restr .*rejc_restr .* (1-prox_restr) .* distInBound,[],2),0);
nr_stud.ok = (nr_stud.refused_wrong_priorities==0) & (nr_stud.given_wrong_priorities==0);
fprintf('Newer hit rate: %0.2f\n',sum(nr_stud.ok)/numel(nr_stud.ok));

if strcmp(select_prxd,'original'), prxd=original; stud.prox = or_stud; end
if strcmp(select_prxd,'new'), prxd=new; stud.prox = ne_stud; end
if strcmp(select_prxd,'newer'), prxd=newer; stud.prox = nr_stud; end

