

%% % 2. Generate MCMC using a Gibbs Sampler
if run_gibbs
    % SYNTAX[ final_vals, priors, run_next_list] = gen_chain_mcmc_mex(folder,priors,init_vals,chain,run_this_list,NITER_by_file,stem)
    [ init_vals, priors ] = gen_chain_mcmc_mex(folder);
    stem = 'chain_'; NITER_by_file=1000;
    if ~exist('run_this_list'); run_this_list=1:400; end

    % Look at the prior and make appropriate changes;


    if resumeAt>0 % resume
        [ final_vals, priors, run_next_list] = gen_chain_mcmc_mex(folder,priors,resumeAt,chain,run_this_list,NITER_by_file,stem,thin_each);
    else % New run
        switch chain
            case 1
                init_vals.V = repmat(sum(init_vals.V.^2,2).^(-1/2),1,size(init_vals.V,2)).*init_vals.V; % Normalize Vs';
                if strcmp(folder,'currentyear1_ts_wl'), rng(13); fprintf('..'); end
                init_vals.rng_state = rng;
                fprintf(''); % Use defaults
            case 2
                init_vals.V = repmat(sum(init_vals.V.^2,2).^(-1/2),1,size(init_vals.V,2)).*init_vals.V; % Normalize Vs';
                num_students= size(init_vals.V,1); grid=linspace(0,1,num_students+2);
                rng(100); init_vals.rng_state = rng; % Changing random seed
                init_vals.V=diag(exp((grid(2:end-1)-.5)*5))*init_vals.V; % Changing initial conditions;
            case 3
                init_vals.V = repmat(sum(init_vals.V.^2,2).^(-1/2),1,size(init_vals.V,2)).*init_vals.V; % Normalize Vs';
                num_students= size(init_vals.V,1); grid=linspace(0,1,num_students+2);
                rng(200); init_vals.rng_state = rng; % Changing random seed
                if strcmp(folder,'currentyear1_ts'), rng(199); fprintf('..'); end
                init_vals.V=diag(exp(-(grid(2:end-1)-.5)*5))*init_vals.V; % Changing initial conditions;
        end
        [ final_vals, priors, run_next_list] = gen_chain_mcmc_mex(folder,priors,init_vals,chain,run_this_list,NITER_by_file,stem,thin_each);
    end

end 

%% % 3. Read a set of chains;
if read_chains 
    
    ch.stem='chain_';
    ch.chain=1;
    ch.list = 200:400;
    chains{1}=ch;
    ch.chain=2;
    chains{2}=ch;
    ch.chain=3;
    chains{3}=ch;


    %%
    if show_diagnosis
        [savedSumFiles,savedThinFiles]= read_mcmc(folder,chains,1,0,1)
        cX = load([folder '/' savedSumFiles{3}]);
    end
    linearf_beta; 
    savedSumFiles = read_mcmc_meanUtility_bs(folder,chains,0,0,1,linearf)

end
%% % 4. Generate tables
if make_the_tables
    
    % % SYNTAX make_table_mcmc(folder,summary_file)
    this_map_names = {'Graham Parks','Haggerty','Baldwin','Morse','Amigos','Cambridgeport',...
        'King Open','Peabody','Tobin','Flet Mayn',...
        'Kenn Long','MLK','King Open Ola'};

    %savedSumFiles = {'chain_summ_1','chain_summ_2','chain_summ_X'}

    make_table_mcmc(folder,'chain_summ_X',this_map_names)
end



if build_rnd_chain, randChains; end

