%% Saves the master file;

% Create folder (if necessary).
if ~isdir(folder)
   mkdir(folder);
   fprintf('Created folder %s\n', folder);
else
   fprintf('Folder %s already exists.\n', folder);
end

% Change a few names to speak to make_tables_mcmc and to have readily
% available references to the variables in the specification;
covariates = Xmat.name;
excluded_ethnicity = eth_list{1};
excluded_language = lang_list{1};
school_names = consolidate.name;
for s =1:numel(school_names),if iscell(school_names{s}), school_names{s}=school_names{s}{1}; end; end
n_students = sum(esample>0);
if isempty(X), X = blkdiag(Xcell{:}); end

% Saving master file;
varlist = {'covariates', 'X', 'consolidate',...
    'constraint_matrix', 'distances', 'method', 'language', 'excluded*',...
    'school_names', 'n_students', 'V',  'n_progs', 'esample','eth_list','lang_list','stud'};
if exist('tag','var'), varlist{end+1} = 'tag'; else fprintf('tag does not exist\n'); end   
 
save([folder '/master.mat'], varlist{:});
fprintf('%s saved!',[folder '/master.mat']);

