
% This script creates matrices that can be premultiplied 
% by B (the vector of coefficients) to obtain meaningful
% parameters.

% Load data and master!
load data
% Construct X, if necessary.
X=[];
load([folder '/master.mat'])
if isempty(X), X = blkdiag(Xcell{:}); end
% Reconstruct cells;
n_stud = numel(paidlunch);
for p = 1:n_progs, Xc{p} = X([1:n_stud]+(p-1)*n_stud,:); end;

include = true;
for p = 1:n_progs, include = include & ~any(isnan(Xc{p}),2); end;
M = [-ones(n_progs)/n_progs+eye(n_progs);  -ones(1,n_progs)/n_progs];
% Average Mean utility.
for p = 1:n_progs, auxCell(p,:) = sparse(mean(Xc{p}(include,:),1)); end; amU = M*auxCell;
clear('auxCell');

% Average Mean utility for paidlunch students;
for p = 1:n_progs, auxCell(p,:) = sparse(mean(Xc{p}(include & paidlunch==1,:),1)); end; amUpaid = M*auxCell;
clear('auxCell');

% Average Mean utility for free-lunch students;
for p = 1:n_progs, auxCell(p,:) = sparse(mean(Xc{p}(include & paidlunch==0,:),1)); end; amUfree = M*auxCell;
clear('auxCell');

linearf.name = {'All Students', 'Paid Lunch','Free Lunch'}
linearf.mat = [amU; amUpaid; amUfree];
