
    % Edit on 10/4 (Paulo Somaini) Diagnosing why we get different results for currentyearav1
    % The modification keep_cols was meant to make sure we include the right deviations. Is this
    % introducing new problems? 
    % I've run all _ts specs with w_keep_cols ==1. It generates a different result only when the student
    % ranks Amigos Bilingual.
    
    w_keep_cols = 1;
    
    for s = s:ns, 
        
        if ~isempty(firststage.constraint_matrix{s})			
            ranked_schools = rank.data(s,:)>0;
            if w_keep_cols
                keep_cols=sum(A(:,find(ranked_schools*A)),2)==0 | ranked_schools';
                con_mat_orig=firststage.constraint_matrix{s}(:,keep_cols)*A(keep_cols,:);
            else
                con_mat_orig=firststage.constraint_matrix{s}*A;
            end
			delrow = sum(abs(con_mat_orig),2)<1e-6;
            tag{s}(~tag{s})=delrow;
            con_mat_orig(delrow,:) = [];
            [~,ia,~]=unique(con_mat_orig,'rows');
            aux = tag{s}(~tag{s}); aux(ia) = true; tag{s}(~tag{s}) = ~aux;
			con_mat = sparse(con_mat_orig(ia,:));;
            
            % Solve for con_mat*v>0
            model=struct();
            
            model.A=sparse(con_mat);
            model.sense='>';
            model.lb=repmat(-Inf,size(con_mat,2),1);   % Gurobi defaults to a lower bound of 0 - need to allow for outside option to be worse
            model.rhs=my_eps*ones(size(con_mat,1),1);
            model.obj=zeros(size(con_mat,2),1);

            params = struct();
            params.Presolve = 0;
            params.outputflag = 0;
            params.FeasibilityTol = 1e-9;

            result = gurobi(model, params);

            % Store whether the student was rationalized or not, and if
            % (s)he was, what is the init utility
			constraint_matrix{s} = con_mat;
            if strcmp(result.status, 'INFEASIBLE')==1
                rationalized_students(s)=false;
                
            else
                V(s,:)=result.x(:);
                assert(all(con_mat*V(s,:)' >0));
            end
            % Set constraint_matrix
            
            fprintf('Student %d: %s, %d of %d constrains are non-redundant (%s)\n',s,result.status,size(constraint_matrix{s},1),size(con_mat_orig,1),folder);
        end
    end
    stud.rationalized =rationalized_students;     
	s = s+1;
	
