
clear;

new_two_step_lottery_estimator = 1;
methods = {'Truthful','Current Year','Current Year Av','Last Year','Mixture','Waitlist'};
if new_two_step_lottery_estimator
    folders = {'truthful1','currentyear1_ts','currentyearav1_ts','lastyear1_ts','mixture1_ts','currentyear1_ts_wl'};
    filename = 'Table_Acceptable_ts.csv'
else
    folders = {'truthful1','currentyear1','currentyearav1','lastyear1','mixture2'};
    filename = 'Table_Acceptable.csv'
end
chains = 1:3;
runs = 200:400;

load('../../estimation/data');

flat = @(x) x(:);
hcdf = @(x) tril(ones(size(x,2)))*sum(x)'/sum(flat(x)); 
fid = fopen(filename, 'w')
fprintf(fid,'Method,Students'); fprintf(fid,',%d',0:13); fprintf(fid,'\n');
for mth = 1:numel(methods)
    load(['../../estimation/' folders{mth} '/master'],'esample');
    
    numAcceptable = 0;
    for ch = chains
        for r =runs 
            file0 = [folders{mth} '/chain_' num2str(ch) '_run_' num2str(r)];
            thisCh = load(['../../estimation/' file0 '.mat'],'all_V');
            numAcceptable =numAcceptable +  hist(squeeze(sum(thisCh.all_V>0,2))',(0:13)+0.5)';
        end
        fprintf('%s\n',file0)
    end
    
    w = hcdf(numAcceptable);
    fprintf(fid,'%s,%s',methods{mth},'All'); fprintf(fid,',%1.3f',w(:)'); fprintf(fid,'\n');
    w = hcdf(numAcceptable(paidlunch(esample)==1,:)); 
    fprintf(fid,'%s,%s',methods{mth},'Paid Lunch'); fprintf(fid,',%1.3f',w(:)'); fprintf(fid,'\n');
    w = hcdf(numAcceptable(paidlunch(esample)==0,:)); 
    fprintf(fid,'%s,%s',methods{mth},'Free Lunch'); fprintf(fid,',%1.3f',w(:)'); fprintf(fid,'\n');
end

fclose(fid);


