load ../../estimation/data.mat

extensions = {'all', '2004', '2005', '2006', '2007', '2008', 'free', 'paid'};
type = {'all', 'y', 'y', 'y', 'y', 'y', 'l', 'l'};
restriction = {[], 2004, 2005, 2006, 2007, 2008, 0, 1};

all_ranks = {'Rank 1', 'Rank 2', 'Rank 3', 'Other','None'};
nranks = numel(all_ranks);
%consolidate.name = {'Baldwin','Haggerty',{'Amigos','Amigos Bilingual'}, 'MLK',...
%    'King Open','Morse','Peabody',{'Tobin','Tobin K4','Tobin K5'},'Flet Mayn',...
%    'Graham Parks', 'Kenn Long','Cambridgeport','King Open Ola'};
consolidate.name = {'Graham Parks','Haggerty','Baldwin','Morse',{'Amigos','Amigos Bilingual'},'Cambridgeport',...
    'King Open','Peabody',{'Tobin','Tobin K4','Tobin K5'},'Flet Mayn',...
    'Kenn Long', 'MLK','King Open Ola'};
    
    
nprogs = numel(consolidate.name);
consolidate.map = zeros(numel(prox.name),1);

all_names = []; all_names_ranks=[];
for pr=1:nprogs
    [isit,where]=ismember(consolidate.name{pr},prox.name);
    consolidate.map(where)=pr;
    all_names{pr} = prox.name{where(1)};
    for r = 1:nranks
        all_names_ranks{(pr-1)*nranks+r} = [all_names{pr} '-' all_ranks{r}];
    end
end
npdata=numel(consolidate.map);
consolidate.map(end+1) = nprogs+1; 
all_names{end+1} = 'None';
for r = 1:nranks
        all_names_ranks{end+1} = ['None-' all_ranks{r}];
end



for t = 1:length(extensions)
    switch type{t}
       case 'all'
	   	years = 2004:2008;
		pl = 0:1;
	   case 'y'
	   	years = restriction{t};
		pl = 0:1;
	   case 'l'
	   	years = 2004:2008;
		pl = restriction{t};
    end

    matrix_rank = zeros(nranks);
    matrix_school = zeros(nprogs+1);
    matrix_school_unass = zeros(nprogs+1);
	matrix_rank_school = zeros(5*(nprogs+1));
    where_okay_years = ismember(year, years);
    where_okay_paid = ismember(paidlunch, pl);
    where_okay = where_okay_years & where_okay_paid;

    good = find(where_okay);
    for i = 1:length(good)
    	index = good(i);
	where_asgn = find(asgn.data(index, :));
	if isempty(where_asgn)
	   which_rank_asgn = 5;
	   where_asgn = npdata + 1;
	else
	   which_rank_asgn = rank.data(index, where_asgn);
	end
	if which_rank_asgn == 0, which_rank_asgn = 4; end
	
	where_regs = find(regs.data(index, :));
    where_rank1 = find(rank.data(index, :)==1);
	if isempty(where_regs)
           which_rank_regs = 5;
	   where_regs = npdata + 1;
    else
           which_rank_regs = rank.data(index, where_regs);
    end
        if which_rank_regs == 0, which_rank_regs = 4; end

    where_asgn = consolidate.map(where_asgn);
    where_regs = consolidate.map(where_regs);
    where_rank1 = consolidate.map(where_rank1);
	matrix_rank(which_rank_asgn, which_rank_regs) =  matrix_rank(which_rank_asgn, which_rank_regs) + 1;
	matrix_school(where_asgn, where_regs) = matrix_school(where_asgn, where_regs) + 1;
	matrix_rank_school((where_asgn-1)*nranks + which_rank_asgn , (where_regs-1)*nranks + which_rank_regs) = ...
        matrix_rank_school((where_asgn-1)*nranks + which_rank_asgn , (where_regs-1)*nranks + which_rank_regs) + 1;
        
    matrix_school_unass(where_rank1, where_regs) = matrix_school_unass(where_rank1, where_regs) + (where_asgn == numel(all_names));
    end

    % Normalize the tables
    % matrix_school = matrix_school ./ repmat(sum(matrix_school, 2), 1, size(matrix_school, 2));
    % matrix_rank = matrix_rank ./ repmat(sum(matrix_rank, 2), 1, size(matrix_rank, 2));

    % Finally, write the matrices
    total = true; % What is the right denominator
    write_asgn_table(['asgn_regs_rank_', extensions{t}, '.csv'], matrix_rank, all_ranks,total);
    write_asgn_table(['asgn_regs_school_', extensions{t}, '.csv'], matrix_school, all_names,~total);
    write_asgn_table_abs(['asgn_regs_rank_school_', extensions{t}, '.csv'], matrix_rank_school, all_names_ranks);
    write_asgn_table(['rank1_regs_school_unass', extensions{t}, '.csv'], matrix_school_unass, all_names,~total);
end
