
% Hack
est.distances(isnan(est.distances))=1.5;
years = unique(data.year)';

filestem=['../../estimation/' est_type '/'];
chainfile = 'chain_summ_X';
load([filestem chainfile]);
num_sim = 1000;

% Dimensions
n_prog=size(est.consolidate.map,1);
n_progs = max(est.consolidate.map);
n_stu = numel(est.esample);

mu=reshape(est.X*mean_B,n_stu,est.n_progs)-est.distances; % Generate mu

% Lotteries
bhl = load(['../../est_lotteries/' est.method]);
asl = load(['../../est_lotteries/' asgn_lott]);
% Allocate memory
V_camb=zeros(n_stu,num_sim);
V_vec=zeros(n_stu,n_prog,num_sim);
chosen_list=zeros(n_stu,3,num_sim);
naiv_list = zeros(n_stu,3,num_sim);
camb_assign=zeros(n_stu,3,num_sim);
naiv_assign=zeros(n_stu,3,num_sim);
rng(100);
%% Simulations
student_set = false(n_stu,1);
%parfor ii=1:n_stu
for ii=1:n_stu
    
    if mod(ii,100)==0,fprintf('.'); end
    if ~isempty(bhl.lott(bhl.student_type(ii)).p)
    student_set(ii)=true;
    muii=mu(ii,:);
    bh.lott = bhl.lott(bhl.student_type(ii));
    as.lott = asl.lott(asl.student_type(ii));
    % Replace reference to the outside option:
    bh.lott.choice(isnan(bh.lott.choice) | bh.lott.choice==0) = n_prog + 1;
    as.lott.choice(isnan(as.lott.choice) | as.lott.choice==0) = n_prog + 1;
 
    for bb=1:num_sim    
        % Sample utlities for student
        Vi=mvnrnd(muii,mean_S);
        Vi = Vi(1,est.consolidate.map);
        Vi0 = [Vi 0];
        
        % Truthful Lott
        all_lot=as.lott.choice;
        iu = all_lot; iu(:) = Vi0(all_lot(:)); % Utility implied by each program ranked
        [~,index] = sortrows(iu); 
        true_lott = index(end);
		
        
        % Chosen Lott according to bh
        V_by_rol = bh.lott.p*Vi';
        V_camb(ii,bb)=max(V_by_rol); 
        indiff = find(V_by_rol==V_camb(ii,bb)); % All indifferent lotteries (index);
        all_indiff_lot=bh.lott.choice(indiff,:); % All indifferent lotteries)
        iu = all_indiff_lot; iu(:) = Vi0(all_indiff_lot(:)); % Utility implied by each program ranked
        [~,index] = sortrows(iu); % if indifferent behave truthfully
        chosen_lott = indiff(index(end));
        
        naiv_list(ii,:,bb)=as.lott.choice(true_lott,:); 
        chosen_list(ii,:,bb)=bh.lott.choice(chosen_lott,:); 
        asAux=chosen_list(ii,:,bb); asAux(isnan(asAux) | asAux==0)=n_prog+1;
        assert(isequal(asAux,all_indiff_lot(index(end),:)));
        
        % Nv: Put down the chosen probabilities
        [~,where_in_p]=ismember(naiv_list(ii,:,bb),1:n_prog);
        where_in_p=where_in_p(where_in_p~=0);  % Remove unranked
        p_temp=zeros(1,3); % temporary vector - to get around parfor restrictions
        p_temp(1:size(where_in_p,2))=as.lott.p(true_lott,where_in_p);
        naiv_assign(ii,:,bb)=p_temp;
        
        % Bh: Put down the chosen probabilities
        [~,where_in_p]=ismember(chosen_list(ii,:,bb),1:n_prog);
        a0 = as.lott.choice(chosen_lott,:); a1 = bh.lott.choice(chosen_lott,:);
        if ~all(a0==a1), 
            [~,chosen_lott]=ismember(chosen_list(ii,:,bb),as.lott.choice,'rows'); 
            fprintf('.')
        end
        where_in_p=where_in_p(where_in_p~=0);  % Remove unranked
        p_temp=zeros(1,3); % temporary vector - to get around parfor restrictions
        p_temp(1:size(where_in_p,2))=as.lott.p(chosen_lott,where_in_p);
        camb_assign(ii,:,bb)=p_temp;        
        
        
        % Store the utilities
        V_vec(ii,:,bb)=Vi;
    end 
    end
end


%out.V_vec(this_yr,:,:)=V_vec;
%out.camb_assign(this_yr,:,:)=camb_assign;

%out.V_camb(this_yr,:,:)=V_camb;
%out.chosen_list(this_yr,:,:)=chosen_list;


%save([filestem chain_name '_cm_counter' ], '-struct','out');

%matlabpool close;

