% Creates the raw tables for the DA counterfactuals

% Clear all except do_specs and run_prep_da_vs_camb
clearvars -except do_specs do_specifications run_prep_da_vs_camb tasks;

% Basic Manual settings
bootstrap_draws = 250;
posterior_draws = 1000;
if ~exist('do_specs','var'), 
    do_specs = {'truthful','current_year','last_year','current_year_av','current_year_wl','mixture_naive','mixture_soph'}; 
end

if ~exist('run_prep_da_vs_camb','var'),
    run_prep_da_vs_camb=false;
    % Set to false if there is no need to recompute point estimates
    % If true: it will recompute the probabilities of each rank for the table
    % using only the original sample (point estimate)
    % If false (default): it will re-read the bootstrap draws, load prep_
    % file and generate the table in csv format.
end

%  Run specs
for do_spec = do_specs, 
    
    spec = do_spec{1};                      
    truthful_behavior = false;
    draws_from        = 'bootstrap';
    
    switch spec
        case 'truthful',        est_type = 'truthful1';          truthful_behavior = true;  draws_from = 'posterior';   
        case 'current_year',    est_type = 'currentyear1_ts'; 
        case 'current_year_av', est_type = 'currentyearav1_ts';
        case 'current_year_wl', est_type = 'currentyear1_ts_wl';
        case 'last_year',       est_type = 'lastyear1_ts';      
        case 'mixture_naive',   est_type = 'mixture1_ts';        truthful_behavior = true;
        case 'mixture_soph',    est_type = 'mixture1_ts';
    end
    
    tab_da_ts;
    
end
    