function s=strxfun(fun,s1,s2)
% STRXFUN (Created by Paulo Somaini 9/29/2016)
% strxfun(fun,s1,s2) applies fun to each field that appears in structures s1 and s2.
% It supports recursive structures.  
s = s1;
fields = fieldnames(s1);
for i=1:numel(fields)
    f = fields{i};
    switch nargin
    case 3
        if isfield(s2,f)
            arg2 = s2.(f);
        else
            arg2 = s2;
        end
        if isstruct(s1.(f))
            s.(f) = strxfun(fun,s1.(f),arg2);
        else
            s.(f) = fun(s1.(f),arg2);
        end
    case 2
        if isstruct(s1.(f))
            s.(f) = strxfun(fun,s1.(f));
        else
            s.(f) = fun(s1.(f));
        end
    end
end

