% 1. Probability if ranked first
% 1.A. Get baseline type. No priority (Average across years and paidlunch status) 
% 1.B. Add proximity priority (Average across years and paidlunch status);
% 1.C. Add sibling priority (Average across years and paidlunch status);


% 2. Probability if ranked second
% 2.A. Get baseline type. No priority (Average across years and paidlunch status) 
% 2.B. Add proximity priority (Average across years and paidlunch status);
% 2.C. Add sibling priority (Average across years and paidlunch status);


% 3. Probability if ranked third
% 3.A. Get baseline type. No priority (Average across years and paidlunch status) 
% 3.B. Add proximity priority (Average across years and paidlunch status);
% 3.C. Add sibling priority (Average across years and paidlunch status);

%Repeat averaging only across years for paidlunch and freelunch;
%method = 'current_year_ts';

load ../../estimation/data;
load(['../../est_lotteries/' method]);

% Find the type of student that does not have any priority in any school.

num_types = numel(lott);
summlott = cell(size(lott));

for type = 1:num_types
	thislott = lott(type); nr = size(thislott.p,1);
    probunassigned = ones(size(thislott.p,1),1);
    thismat = zeros(3,size(thislott.p,2));
    
    % Populate thismat
    for row = 1:size(thismat,1)
        pass = zeros(nr,1);
        for col = 1:size(thismat,2)
            thesereports = thislott.choice(:,row)==col;
            pass(thesereports) = thislott.p(thesereports,col);
            aux = (pass(thesereports)...
                ./probunassigned(thesereports));
            thismat(row,col) = max([0; mean(aux(probunassigned(thesereports)>0))]); % Deal with NaNs when probunassigned =0; 
        end
        probunassigned = probunassigned - pass;
    end
     
    %if mod(type,10)==0, fprintf('Type: %d\n',type); end;
    summlott{type} = thismat;
end
% Average assignment probabilities;
aap.all = thismat*0; % All students
aap.paid.all = aap.all; % paid students
aap.free.all = aap.all; % free students
aap.prox = aap.all; % students with prox priority
aap.sibl = aap.all; % students with sibling priority
aap.reg = aap.all; % students with sibling priority
aap.paid.reg = aap.all; % paid students
aap.free.reg = aap.all; % free students
aap.paid.prox = aap.all; % paid students prox
aap.free.prox = aap.all; % free students prox
aap.paid.sibl = aap.all; % paid students sibl
aap.free.sibl = aap.all; % free students sibl
% Counter
c=aap;
for s =1:numel(student_type)
    if ~isempty(summlott{student_type(s)})
	eligs = ineg.data(s,:)==0;
    aap.all(:,eligs) = (c.all(:,eligs).*aap.all(:,eligs) + summlott{student_type(s)}(:,eligs))./(c.all(:,eligs)+1); c.all(:,eligs) = c.all(:,eligs)+1;
    if paidlunch(s)
        aap.paid.all(:,eligs) = (c.paid.all(:,eligs).*aap.paid.all(:,eligs) + summlott{student_type(s)}(:,eligs))./(c.paid.all(:,eligs)+1); c.paid.all(:,eligs)= c.paid.all(:,eligs)+1;
        where_prox = find(prxd.data(s,:) & eligs); % find proximity priority;
        aap.paid.prox(:,where_prox) = (c.paid.prox(:,where_prox).*aap.paid.prox(:,where_prox)...
            + summlott{student_type(s)}(:,where_prox))./(c.paid.prox(:,where_prox)+1); c.paid.prox(:,where_prox) = c.paid.prox(:,where_prox)+1;
        aap.prox(:,where_prox) = (c.prox(:,where_prox).*aap.prox(:,where_prox)...
            + summlott{student_type(s)}(:,where_prox))./(c.prox(:,where_prox)+1); c.prox(:,where_prox) = c.prox(:,where_prox)+1;
        where_sibl = find(sibl.data(s,:) & eligs); % find siblimity priority;
        aap.paid.sibl(:,where_sibl) = (c.paid.sibl(:,where_sibl).*aap.paid.sibl(:,where_sibl)...
            + summlott{student_type(s)}(:,where_sibl) )./(c.paid.sibl(:,where_sibl)+1); c.paid.sibl(:,where_sibl) = c.paid.sibl(:,where_sibl)+1;
        aap.sibl(:,where_sibl) = (c.sibl(:,where_sibl).*aap.sibl(:,where_sibl)...
            + summlott{student_type(s)}(:,where_sibl) )./(c.sibl(:,where_sibl)+1); c.sibl(:,where_sibl) = c.sibl(:,where_sibl)+1;
        where_reg = find(prox.data(s,:)==0 & sibl.data(s,:)==0 & eligs); % find regimity priority;
        aap.paid.reg(:,where_reg) = (c.paid.reg(:,where_reg).*aap.paid.reg(:,where_reg)...
            + summlott{student_type(s)}(:,where_reg))./(c.paid.reg(:,where_reg)+1); c.paid.reg(:,where_reg) = c.paid.reg(:,where_reg)+1;
        aap.reg(:,where_reg) = (c.reg(:,where_reg).*aap.reg(:,where_reg)...
            + summlott{student_type(s)}(:,where_reg))./(c.reg(:,where_reg)+1); c.reg(:,where_reg) = c.reg(:,where_reg)+1;
    else
        aap.free.all(:,eligs) = (c.free.all(:,eligs).*aap.free.all(:,eligs) + summlott{student_type(s)}(:,eligs))./(c.free.all(:,eligs)+1); c.free.all(:,eligs) = c.free.all(:,eligs)+1;
        where_prox = find(prxd.data(s,:) & eligs) ; % find proximity priority;
        aap.free.prox(:,where_prox) = (c.free.prox(:,where_prox).*aap.free.prox(:,where_prox)...
            + summlott{student_type(s)}(:,where_prox))./(c.free.prox(:,where_prox)+1); c.free.prox(:,where_prox) = c.free.prox(:,where_prox)+1;
        aap.prox(:,where_prox) = (c.prox(:,where_prox).*aap.prox(:,where_prox)...
            + summlott{student_type(s)}(:,where_prox))./(c.prox(:,where_prox)+1); c.prox(:,where_prox) = c.prox(:,where_prox)+1;
        where_sibl = find(sibl.data(s,:) & eligs); % find siblimity priority;
        aap.free.sibl(:,where_sibl) = (c.free.sibl(:,where_sibl).*aap.free.sibl(:,where_sibl)...
            + summlott{student_type(s)}(:,where_sibl))./(c.free.sibl(:,where_sibl)+1); c.free.sibl(:,where_sibl) = c.free.sibl(:,where_sibl)+1;
        aap.sibl(:,where_sibl) = (c.sibl(:,where_sibl).*aap.sibl(:,where_sibl)...
            + summlott{student_type(s)}(:,where_sibl))./(c.sibl(:,where_sibl)+1); c.sibl(:,where_sibl) = c.sibl(:,where_sibl)+1;
        where_reg = find(prox.data(s,:)==0 & sibl.data(s,:)==0 & eligs); % find regimity priority;
        aap.free.reg(:,where_reg) = (c.free.reg(:,where_reg).*aap.free.reg(:,where_reg)...
            + summlott{student_type(s)}(:,where_reg))./(c.free.reg(:,where_reg)+1); c.free.reg(:,where_reg) = c.free.reg(:,where_reg)+1;
        aap.reg(:,where_reg) = (c.reg(:,where_reg).*aap.reg(:,where_reg)...
            + summlott{student_type(s)}(:,where_reg))./(c.reg(:,where_reg)+1); c.reg(:,where_reg) = c.reg(:,where_reg)+1;
    end
    end
end

consolidate.name = {'Graham Parks','Haggerty','Baldwin','Morse','Amigos','Amigos Bilingual','Cambridgeport',...
	'King Open','Peabody','Tobin','Tobin K4','Tobin K5','Flet Mayn',...
    'Kenn Long','MLK','King Open Ola'};

fid = fopen([method '_EstimatedLott.csv'], 'w');

% function printTable(fid,table,colname,rowname,fixedrows)
fixedrows.name = {'Students','Proximity'};
fprintf(fid,',,\n')
table =aap.all; fixedrows.value = {'All','Any'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.paid.all; fixedrows.value = {'Paid Lunch','Any'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.free.all; fixedrows.value = {'Free Lunch','Any'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.prox; fixedrows.value = {'All','Proximity'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.sibl; fixedrows.value = {'All','Sibling'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.reg; fixedrows.value = {'All','None'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.paid.reg; fixedrows.value = {'Paid Lunch','None'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.free.reg; fixedrows.value = {'Free Lunch','None'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.paid.prox; fixedrows.value = {'Paid Lunch','Proximity'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.free.prox; fixedrows.value = {'Free Lunch','Proximity'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.paid.sibl; fixedrows.value = {'Paid Lunch','Sibling'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);
fprintf(fid,',,\n')
table =aap.free.sibl; fixedrows.value = {'Free Lunch','Sibling'}
printTable(fid,table,prxd.name,{'First','Second','Third','Ranked'},fixedrows,consolidate);

fclose(fid);

