% This code calculates the losses in terms of distances if individuals were
% naive under different utility assumptions. 

%% Set Parameters and filename
%clear;

%est_type = 'lastyear1';
%optimal_behavior = false;

% Use current_year to compute actual assignment probabilities;
% asgn_lott = 'current_year';

num_sim = 1000;


% Set up

load('../../estimation/data.mat');
addpath ../../estimation;

% Specification
filestem=['../../estimation/' est_type '/'];
load([filestem 'master']);

%matlabpool close force;
%matlabpool;

% Hack
distances(isnan(distances))=1.5;
years = unique(year)';

%% Read in the Random Chain 
load([filestem chainfile]);
num_sim = min(num_sim,size(B,2));

% Number of students
n_stu_counter=numel(student_id);

% Lotteries


if optimal_behavior
    bh_lott=load(['../../est_lotteries/' asgn_lott]);
    as_lott=bh_lott;
    flag =['o' chainfile(13:end)];
else
    if override_method, method = method_id; end
    bh_lott=load(['../../est_lotteries/' method]);
    as_lott=load(['../../est_lotteries/' asgn_lott]);
    flag = ['b' chainfile(13:end)];
end


%X=blkdiag(Xcell{:}); % Get X for all students
n_prog=size(consolidate.map,1);

% Mean utilities at B_hat

% Allocate memory
V_camb=zeros(n_stu_counter,num_sim);
V_vec=zeros(n_stu_counter,n_prog,num_sim);
V_camb_true = zeros(n_stu_counter,num_sim);

list_true=zeros(n_stu_counter,3,num_sim);
list_camb=zeros(n_stu_counter,3,num_sim);

% Needed to figure out Boston outcome/preferences

%% Simulations

student_set = false(n_stu_counter,1);
for ii=1:n_stu_counter, 
    if ~isempty(bh_lott.lott(bh_lott.student_type(ii)).p), student_set(ii)=true; end
end

tic
parfor bb=1:num_sim    
		mu=reshape(X*B(:,bb),n_stu_counter,n_progs)-distances; % Generate mu
        % Sample utlities for each student
        V=mvnrnd(mu,S(:,:,bb)); V=V(:,consolidate.map);
        % Choose a p - get indirect utility of top choice
        for ii = 1:n_stu_counter
            if student_set(ii)
            Vo = [V(ii,:) 0];
            this_bh_lott = bh_lott.lott(bh_lott.student_type(ii));
            V_by_rol = this_bh_lott.p*V(ii,:)';
            indiff = find(V_by_rol==max(V_by_rol)); % All indifferent lotteries (index);
            all_indiff_lot=this_bh_lott.choice(indiff,:); % All indifferent lotteries)
            all_indiff_lot(isnan(all_indiff_lot) | all_indiff_lot==0)=n_prog+1; % replace reference to the outside option
            iu = all_indiff_lot; iu(:) = Vo(1,all_indiff_lot(:)); % Utility implied by each program ranked
            [~,index] = sortrows(iu); % if indifferent behave truthfully
            chosen_lott = indiff(index(end)); 
            list_camb(ii,:,bb)=this_bh_lott.choice(chosen_lott,:); 
            asAux=list_camb(ii,:,bb); asAux(isnan(asAux) | asAux==0)=n_prog+1;
            assert(isequal(asAux,all_indiff_lot(index(end),:)));

            %truth telling:
            all_lot=this_bh_lott.choice;
            all_lot(isnan(all_lot) | all_lot==0)=n_prog+1; % replace reference to the outside option
            iu = all_lot; iu(:) = Vo(1,all_lot(:)); % Utility implied by each program ranked
            [~,index] = sortrows(iu); % if indifferent behave truthfully
            chosen_lott_t = index(end); 
            list_true(ii,:,bb)=this_bh_lott.choice(chosen_lott_t,:);
            asAux=list_true(ii,:,bb); asAux(isnan(asAux) | asAux==0)=n_prog+1;
            assert(isequal(asAux,all_lot(index(end),:)));
            
            % Assign actual utilities:
            this_as_lott = as_lott.lott(as_lott.student_type(ii));
            a0 = this_as_lott.choice(chosen_lott,:); a0(isnan(a0))=0; 
            a1 = this_bh_lott.choice(chosen_lott,:); a1(isnan(a1))=0; assert(all(a0==a1));
            a0 = this_as_lott.choice(chosen_lott_t,:); a0(isnan(a0))=0; 
            a1 = this_bh_lott.choice(chosen_lott_t,:); a1(isnan(a1))=0; assert(all(a0==a1));
            % The assertions above verify that the assignment and behavioral lotteries have the same ordering of choices.
            V_camb(ii,bb)= this_as_lott.p(chosen_lott,:)*V(ii,:)';
            V_camb_true(ii,bb) = this_as_lott.p(chosen_lott_t,:)*V(ii,:)';
            end
        end
            
        
        fprintf('.'); if mod(bb,100)==0, fprintf('\n'); end
        % Store the utilities
        V_vec(:,:,bb)=V;
end

save([est_type '_' flag '_Losses_Posterior.mat'],'list_camb','list_true','V_camb_true','V_camb','student_set')

Table_Losses_posterior
toc


		






