%est_method='currentyear1'; % How we compute the utility
load('../../estimation/data.mat');
load([est_type '_' flag '_Losses_Posterior.mat'],'list_camb','list_true','V_camb_true','V_camb','student_set')
filestem=['../../estimation/' est_type '/'];
load([filestem 'master']);

stu_frc = squeeze(all(list_true == list_camb,2));
loss  = V_camb - V_camb_true;

n_stu = size(stu_frc,1);

wrline= @(fid,rown,which) fprintf(fid,'%s,%3.4f,%3.4f,%3.4f,%3.4f,%3.4f,%3.4f\n', rown, mean(mean(stu_frc(which,:),1),2), std(mean(stu_frc(which,:),1)), mean(mean(loss(which,:),1),2), std(mean(loss(which,:),1)),mean(std(loss(which,:),1),2), std(std(loss(which,:),1)));                 
% Output the tables
% All students, iterate choices
A = sparse(1:numel(consolidate.map),consolidate.map,ones(numel(consolidate.map),1));
modal_pref = mode(squeeze(list_true(:,1,:)),2); ix = find(modal_pref>0);
pref = sparse(ix,consolidate.map(modal_pref(ix)),1);
prox_p = (prxd.data*A>0);
sibl_p = (sibl.data*A>0);
anyp_pref = sum((prox_p + sibl_p).* pref,2)==1;
problems = full(sum(sum(pref,2)==0)); fprintf('Problems: %d',problems)
fid = fopen([est_type '_' flag '_Losses_posterior.csv'], 'w');
fprintf(fid,'Students,Year,Truthful Optimal,, Mean Loss,, Std Loss,,\n');
fprintf(fid,',,mean,s.d., mean,s.d., mean,s.d.\n');

for yr=[0,2004,2005,2006,2007,2008]
    which_students = student_set & (year-yr)*yr==0;
    wrline(fid,['All,',num2str(yr)],which_students);
    % Free/Reduced lunch students, iterate choices
    which_students = student_set & ~logical(paidlunch)  & (year-yr)*yr==0;
    wrline(fid,['Free Lunch,',num2str(yr)],which_students);
    % Paidlunch students, iterate choices
    which_students = student_set & logical(paidlunch) & (year-yr)*yr==0;
    wrline(fid,['Paid Lunch,',num2str(yr)],which_students);
    % Rationalizes students, iterate choices
    which_students = student_set & as_lott.rationalized_students & (year-yr)*yr==0;
    wrline(fid,['Rationalized,',num2str(yr)],which_students);
	for et = 1:numel(ethn.name)
		which_students = student_set & (logical(ethn.data(:,et))  & (year-yr)*yr==0);
		wrline(fid,[ethn.name{et} ',' num2str(yr)],which_students);
	end
	for et = 1:numel(ethn.name)
		which_students = student_set & (logical(ethn.data(:,et)) & logical(paidlunch) & (year-yr)*yr==0);
		wrline(fid,[ethn.name{et} '(PL),' num2str(yr)],which_students);
	end
	for et = 1:numel(ethn.name)
		which_students = student_set & (logical(ethn.data(:,et)) & ~logical(paidlunch) & (year-yr)*yr==0);
		wrline(fid,[ethn.name{et} '(FL),' num2str(yr)],which_students);
	end
	for et = 0:1
		which_students = student_set & (logical(anyp_pref==et)  & (year-yr)*yr==0);
		wrline(fid,['Any Priority =',num2str(et),',', num2str(yr)],which_students);
	end
	for et = 0:1
		which_students = student_set & (logical(anyp_pref==et) & logical(paidlunch) & (year-yr)*yr==0);
		wrline(fid,['Any Priority =',num2str(et),' (PL),', num2str(yr)],which_students);
	end
	for et = 0:1
		which_students = student_set & (logical(anyp_pref==et) & ~logical(paidlunch) & (year-yr)*yr==0);
		wrline(fid,['Any Priority =',num2str(et),' (FL),', num2str(yr)],which_students);
	end
	
	
end
fclose(fid);

