function fancy_regress(y,x,g)


% OLS - Classical SE
iXX = inv(x'*x);
b = iXX*(x'*y);
e = y - x*b;
se = sqrt(var(e)*diag(iXX));

rse = sqrt(diag( iXX*(bsxfun(@times,x,e.^2)'*x)*iXX ));

G = unique(g, 'rows'); M = size(G,1);
    % Now calculate the "meat" of the sandwich variance estimator.
    % See "Robust Inference with Multi-way Clustering"
    % by A. Colin Cameron, Jonah B. Gelbach, and Douglas L. Miller for more
    % detail.
 mid = 0;    
    % This code handles clusters defined by more than one variable. It
    % treats observations having the same value for ALL cluster
    % variables as members of the same cluster.
 for i=1:size(G,1)
      test=[1:size(g,1)]';
      for j=1:size(G,2)
        test2 = find(g(:,j)==G(i,j));
        test=intersect(test,test2);
      end
      X_g = x(test,:);
      e_g = e(test,:);
      mid = mid + X_g'*e_g*e_g'*X_g;
end;
cse = sqrt(diag( iXX*mid*iXX ));  

fprintf('Est: %3.5f, Classical SE: %3.5f, t-stat: %3.5f, p-val: %3.5f\n',b(1),se(1),b(1)/se(1),2*normcdf(-abs(b(1)/se(1))));
fprintf('Est: %3.5f, Hetsk Rob SE: %3.5f, t-stat: %3.5f, p-val: %3.5f\n',b(1),rse(1),b(1)/rse(1),2*normcdf(-abs(b(1)/rse(1))));
fprintf('Est: %3.5f, Cluster R SE: %3.5f, t-stat: %3.5f, p-val: %3.5f\n',b(1),cse(1),b(1)/cse(1),2*normcdf(-abs(b(1)/cse(1))));


