function [bin_locs, matrix] = make_bins(xvals, cutoff, nbins)

tnbins = sum(nbins);
matrix = zeros(length(xvals), tnbins);
edges_low = quantile(xvals(xvals < cutoff), (0:nbins(1)-1)/nbins(1));
edges_high = quantile(xvals(xvals > cutoff), (1:nbins(2))/nbins(2));
edges = [edges_low, cutoff, edges_high];

for i = 1:length(xvals)
    if ~isnan(xvals(i))
        where = sum(xvals(i) > edges);
        if where == 0, where = 1; end
        matrix(i, where) = 1;
    else
        matrix(i, :) = NaN;
    end
end

bin_locs = zeros(tnbins, 1);
for i = 1:length(bin_locs)
    bin_locs(i) = mean(xvals(matrix(:, i) == 1));
end

