
clearvars -except tasks do_*

%% Load the file(s)

lottery_data = importdata('../../lottery_file.csv', ',');
%% Assign variables;
for columnNumber = 1:numel(lottery_data.colheaders)
    exec=strcat(lottery_data.colheaders(columnNumber),'=lottery_data.data(:,columnNumber);');
    eval(exec{1});
end

clear('exec');
ns = numel(student_id);

load '../../estimation/data.mat'

sch1 = sch_prog1 - paidlunch; % Just the school;
sch2 = sch_prog2 - paidlunch;
sch3 = sch_prog3 - paidlunch;
assert(all(mod([sch1;sch2;sch3],10)==0 | isnan([sch1;sch2;sch3]))); %NaN or multiples of 10.

% Assigned School
asgsch = asg_sch_prog - paidlunch;
assert(all(mod(asgsch,10)==0 | isnan(asgsch))); %NaN or multiples of 10.
assigned = 1*(asgsch==sch1) + 2*(asgsch==sch2) + 3*(asgsch==sch3) + 10*isnan(asgsch);
save('AssignmentData.mat','assigned')

% Sanity check;
fprintf('1st Choice: %d, 2nd Choice: %d, 3rd Choice: %d, Unass: %d\n',...
    sum(assigned==1),sum(assigned==2),sum(assigned==3),sum(assigned==10))
% RejectedR
nprogs = size(rank.data,2);
rejected = (rank.data > 0) & rank.data < repmat(assigned,1,nprogs);
points = (4 - rank.data + 0.25*prox.data + 0.5*sibl.data).*rejected;
% Didn't rank = 0; Ranked 3rd: 1+P+S, Ranked 2nd: 2+P+S, Ranked 3rd: 3+P+S;


rejc.all = []; rejc.free = []; rejc.paid = [];
rejc.year = unique(year); rejc.name = rank.name;
kpcx=rejc; rnk1=rejc; rnk2=rejc; rnk3=rejc; rnka=rejc; 

for yr = unique(year)'
	rejc.all =[rejc.all; max(points(year==yr,:),[],1)];
    rejc.paid =[rejc.paid; max(points(year==yr & paidlunch,:),[],1)];
    rejc.free =[rejc.free; max(points(year==yr & ~paidlunch,:),[],1)];
    rnk1.all =[rnk1.all; sum(rank.data(year==yr,:)==1,1)];
    rnk1.paid =[rnk1.paid; sum(rank.data(year==yr & paidlunch,:)==1,1)];
    rnk1.free =[rnk1.free; sum(rank.data(year==yr & ~paidlunch,:)==1,1)];
    rnk2.all =[rnk2.all; sum(rank.data(year==yr,:)==2,1)];
    rnk2.paid =[rnk2.paid; sum(rank.data(year==yr & paidlunch,:)==2,1)];
    rnk2.free =[rnk2.free; sum(rank.data(year==yr & ~paidlunch,:)==2,1)];
    rnk3.all =[rnk3.all; sum(rank.data(year==yr,:)==3,1)];
    rnk3.paid =[rnk3.paid; sum(rank.data(year==yr & paidlunch,:)==3,1)];
    rnk3.free =[rnk3.free; sum(rank.data(year==yr & ~paidlunch,:)==3,1)];
    rnka.all =[rnka.all; sum(rank.data(year==yr,:)>0,1)];
    rnka.paid =[rnka.paid; sum(rank.data(year==yr & paidlunch,:)>0,1)];
    rnka.free =[rnka.free; sum(rank.data(year==yr & ~paidlunch,:)>0,1)];
end

kpcx.all = squeeze(kpct.data(:,3,:))';
kpcx.free = squeeze(kpct.data(:,2,:))';
kpcx.paid = squeeze(kpct.data(:,1,:))';


fid = fopen('RejectedStudent.csv', 'w');
print_now;
fclose(fid);
consolidate.name = {'Graham Parks','Haggerty','Baldwin','Morse',{'Amigos','Amigos Bilingual'},'Cambridgeport',...
	'King Open','Peabody','Tobin',{'Tobin K4','Tobin K5'},'Flet Mayn',...
    'Kenn Long','MLK','King Open Ola'};

rejc = consolidateSchools(consolidate,rejc,'max');
rnk1 = consolidateSchools(consolidate,rnk1,'sum');
rnk2 = consolidateSchools(consolidate,rnk2,'sum');
rnk3 = consolidateSchools(consolidate,rnk3,'sum');
rnka = consolidateSchools(consolidate,rnka,'sum');
kpcx = consolidateSchools(consolidate,kpcx,'sum');


fid = fopen('RejectedStudentCons.csv', 'w');
print_now;
fclose(fid);
